# -*- coding: utf-8 -*-

#1a) Scrivere una funzione mysqrt(v,d) che, dato un numero v e un numero d di 
# cifre decimali significative, determini la radice quadrata r di v con un errore 
# strettamente inferiore a 10**(-(d+2). 
# Per far questo, implementare un algoritmo basato sulla seguente osservazione:
# Sia v il valore dato, e r la sua radice. Sia a una approssimazione di r. 
# Allora, se abbiamo ab=v, si deduce che b (ottenibile come  b=v/a) sarà una 
# approssimazione per difetto di r se a lo è per eccesso, o viceversa. 
# Possiamo allora ottenere una migliore approssimazione di r  come  a′=(a+b)/2.
# Questo calcolo potrà essere reiterato fino a che non si ottenga la tolleranza 
# desiderata.
# La funzione mysqrt(v,d) dovrà restituire una stringa con la rappresentazione 
# della radice (come float) con un massimo di d cifre decimali.
#
# Es. 
# mysqrt(2,9)    # -> '1.414213562'
 

def mysqrt(v,d):
    """
    Returns an approximation with error < e of sqrt(v), as a string that
    represents such a result with up to d decimal places.
    """ 
    e = 10 ** (-(d+2))
    a = float(v)
    b = v/a
    while (abs(a-b) >= e):
        a = (a+b)/2
        b = v/a
    
    s = str(a)
    i = s.find('.')
    return s[:i]+s[i:i+d+1]

