# -*- coding: utf-8 -*-

#4a) Nel modulo globalign.py la funzione galign_tree restituisce un albero che 
# rappresenta le scelte fatte per ottenere tutti i possibili allineamenti; 
# ciascun nodo è istanza della classe Node.
# Si definisca una funzione minGaps che, preso in ingresso un albero 
# restituito da galign_tree, restituisca il minimo numero di gap "completi" 
# che si possono trovare negli allineamenti presenti nelle foglie dell'albero 
# (per gap "completo" si intende una sequenza ininterrotta di "-" delimitata 
# a destra e a sinistra da caratteri diversi da "-").
# Ogni singolo allineamento è rappresentato come lista delle due 
# "gapped strings".


def numComplGaps(s):
    """Returns the number of complete gaps in the input string.
    """
    n=0
    last_ch=""
    for c in s:
        if c=="-" and last_ch!="-":
            n+=1
        last_ch = c
    return n


def minGaps(a):
    """Returns the minimun number of complete gaps across all the 
    pairwise alignments in the leaves of the input tree (as the one returned 
    by galign_tree in module globalign).
    """
    
    if a.clist:
        res = []
        for child in a.clist:
            res.append(minGaps(child))
        return min(res)
    else:
        return numComplGaps(a.info[0])+numComplGaps(a.info[1])
        
